<?php
include_once "config.php";
$title = "Minimal Mail - Message List";
include_once "header.php";

if ($_REQUEST[page]) { $_SESSION[page] = $_REQUEST[page]; }
if (! $_SESSION[page]) { $_SESSION[page] = 1; }

$sorted = imap_sort($mbox, "SORTARRIVAL", 1);
if ($debug) { echo "DEBUG: sorted: "; foreach ($sorted as $tmp) { echo "$tmp "; } echo "<br>\n"; }
$msgs = array_chunk($sorted, $per_page);
$maxpage = count($msgs);
$msgs = $msgs[$_SESSION[page]-1];
if ($debug) { echo "DEBUG: msgs: "; foreach ($msgs as $tmp) { echo "$tmp "; } echo "<br>\n"; }

if ($debug) {
  $result = imap_headers($mbox);
  echo "<pre>\n";
  print_r($result);
  echo "</pre>\n";
}

echo "<b>Actions:</b> ";
echo "<a href=\"compose.php\">Compose</a>&nbsp;&nbsp; ";
echo "<a href=\"folders.php\">Folders</a>&nbsp;&nbsp; ";
echo "<a href=\"logout.php\">LogOut</a>&nbsp;&nbsp; ";
echo "<br>\n";

echo "<b>Current Folder:</b> $_SESSION[folder]<br>\n";
echo "<br>\n";

if ( $_SESSION[page] == 1 ) { 
  $prev = 1; 
  echo "First&nbsp;&nbsp; ";
  echo "Prev&nbsp;&nbsp; ";
}
else { 
  $prev = $_SESSION[page] - 1; 
  echo "<a href=\"messagelist.php?page=1\">First-1</a>&nbsp;&nbsp; ";
  echo "<a href=\"messagelist.php?page=$prev\">Prev-$prev</a>&nbsp;&nbsp; ";
}
echo "<a href=\"messagelist.php\">Refresh-$_SESSION[page]</a>&nbsp;&nbsp; ";
if ( $_SESSION[page] >= $maxpage ) { 
  $next = $maxpage; 
  echo "Next&nbsp;&nbsp; ";
  echo "Last&nbsp;&nbsp; ";
}
else { 
  $next = $_SESSION[page] + 1; 
  echo "<a href=\"messagelist.php?page=$next\">Next-$next</a>&nbsp;&nbsp; ";
  echo "<a href=\"messagelist.php?page=$maxpage\">Last-$maxpage</a>&nbsp;&nbsp; ";
}
echo "<br>\n";

echo "<hr>\n";
//$result = imap_fetch_overview($mbox,"1:{$MC->Nmsgs}", implode($msgs, ','), 0);
$result = imap_fetch_overview($mbox, implode($msgs, ','), 0);
$result = array_reverse($result);
echo "<table>\n";
foreach ($result as $header) {
  $search = array("<", ">");
  $replace = array("&lt;", "&gt;");
  $datearray=date_parse($header->date);
  $from = substr(imap_utf8($header->from), 0, $fromlength);
  $from = str_replace($search, $replace, $from);
  $subject = substr(quoted_printable_decode(imap_utf8($header->subject)), 0, $sublength);
  $subject = str_replace($search, $replace, $subject);
  echo "<tr>";
  echo "<td>".sprintf("%02s",$datearray[month])."/".sprintf("%02s",$datearray[day])." ".sprintf("%02s",$datearray[hour]).":".sprintf("%02s",$datearray[minute])."</td>";
  echo "<td>$from</td>";
  echo "<td><a href=\"message.php?id=$header->msgno&mode=PLAIN\">$subject</a></td>";
  echo "</tr>\n";
}
echo "</table>\n";

echo "<hr>\n";

if ( $_SESSION[page] == 1 ) { 
  $prev = 1; 
  echo "First&nbsp;&nbsp; ";
  echo "Prev&nbsp;&nbsp; ";
}
else { 
  $prev = $_SESSION[page] - 1; 
  echo "<a href=\"messagelist.php?page=1\">First-1</a>&nbsp;&nbsp; ";
  echo "<a href=\"messagelist.php?page=$prev\">Prev-$prev</a>&nbsp;&nbsp; ";
}
echo "<a href=\"messagelist.php\">Refresh-$_SESSION[page]</a>&nbsp;&nbsp; ";
if ( $_SESSION[page] >= $maxpage ) { 
  $next = $maxpage; 
  echo "Next&nbsp;&nbsp; ";
  echo "Last&nbsp;&nbsp; ";
}
else { 
  $next = $_SESSION[page] + 1; 
  echo "<a href=\"messagelist.php?page=$next\">Next-$next</a>&nbsp;&nbsp; ";
  echo "<a href=\"messagelist.php?page=$maxpage\">Last-$maxpage</a>&nbsp;&nbsp; ";
}

echo "<br><br>\n";

include_once "footer.php";
?>